


#ifndef __DEFS_H__
#define __DEFS_H__


#ifdef GP32

#define IS_LITTLE_ENDIAN

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include <gp32.h>
#include "zlib\zlib-gp32.h"

#define memcpy(a,b,c) gm_memcpy(a,b,c)
#define strcpy gm_strcpy
#define strcat gm_strcat
#define memset(a,b,c) gm_memset(a,b,c)
#define free(a) gm_free(a)
#define malloc(a) ((void *)gm_zi_malloc(a))
#define realloc(a,b) ((void *)gm_realloc(a,b))
#define calloc(a,b) ((void *)gm_zi_malloc(a*b))

#define INLINE static __inline

#undef byte
#undef word

#endif



#ifdef IS_LITTLE_ENDIAN
#define LO 0
#define HI 1
#else
#define LO 1
#define HI 0
#endif

//ifndef GP32
typedef unsigned char byte;
//endif

typedef unsigned char un8;
typedef unsigned short un16;
typedef unsigned int un32;

typedef signed char n8;
typedef signed short n16;
typedef signed int n32;

//ifndef GP32
typedef un16 word;
//endif
typedef word addr;





#endif

